/**************************************************************************

  1.8' 128 x 160 RGB TFT LCD
  DRIVER IC: ST7735

  MaiaR create

 **************************************************************************/

#include <Adafruit_GFX.h>    // Core graphics library
#include <Adafruit_ST7735.h> // Hardware-specific library for ST7735
#include <SPI.h>
#include "LoRa.h"

#define TSIZE 2
#define RPOS 80
#define SX 70
#define SY 66
#define SR 7

#define TFT_CS    3
#define TFT_RST  25
#define TFT_DC    2

// For 1.44" and 1.8" TFT with ST7735 use:
Adafruit_ST7735 tft = Adafruit_ST7735(TFT_CS, TFT_DC, TFT_RST);

void setup(void) {
  // Use this initializer if using a 1.8" TFT screen:
  tft.initR(INITR_GREENTAB);  // Init ST7735S chip, green tab

  tft.setTextSize(TSIZE);
  tft.fillScreen(ST77XX_BLACK);
  tft.setTextColor(ST77XX_WHITE);
  tft.setCursor(0, 20);
  tft.println("LoRa");
  tft.println("Display");
  tft.println("Stand-by");

  LoRaInit();
 
}

void loop() {
  if (Serial1.available() > 0) {
    String rxs = Serial1.readString();
    Serial.print(rxs);
    char Buf[5];
    rxs.toCharArray(Buf, 5);
    int16_t rssi = strtol(Buf,NULL,16);
    rxs = rxs.substring(4);
    tft.fillScreen(ST77XX_BLACK);
    tft.fillCircle(SX, SY, SR, ST77XX_GREEN);
    tft.setCursor(0, 8);
    if (rxs.length() > 12){
      tft.println("T:" + rxs.substring( 2, 6 ) + " 'C " );
      tft.println("H:" + rxs.substring( 8,12 ) + " % "  );
      if (rxs.length() > 16){
        tft.println("P:" + rxs.substring(14,18 ) + " hPa ");
      }
    } else {
      tft.println(rxs);
    }
    tft.setCursor(0, RPOS);
    tft.print("R: ");
    tft.print(rssi);
    tft.print(" dB");
    delay(400);
    tft.fillCircle(SX, SY, SR, ST77XX_BLACK);
  }
}
